> For the complete documentation index, see [llms.txt](https://manual.docs.microstream.one/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://manual.docs.microstream.one/cache/configuration/properties.md).

# Properties

{% hint style="warning" %}
**This is the manual for older MicroStream versions (Version < 5.0).**

**The new documentation (Version >= 5.0) is located at:**

[https://docs.microstream.one/](https://docs.microstream.one/manual)
{% endhint %}

These are the available properties of the `CacheConfiguration` type. The names are used accordingly in the external configuration files. They can be found as constants in `CacheConfigurationPropertyNames`.

| Property                         | Description                                                                                                                                                                                 |
| -------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| keyType                          | Determines the required type of keys for the Cache.                                                                                                                                         |
| valueType                        | Determines the required type of values for the Cache.                                                                                                                                       |
| storageConfigurationResourceName | Path for the  [storage configuration](/data-store/configuration.md#external-configuration) for the backing store.                                                                           |
| cacheLoaderFactory               | A CacheLoader should be configured for "Read Through" caches to load values when a cache miss occurs.                                                                                       |
| cacheWriterFactory               | A CacheWriter is used for write-through to an external resource.                                                                                                                            |
| expiryPolicyFactory              | Determines when cache entries will expire based oncreation, access and modification operations.                                                                                             |
| evictionManagerFactory           | Clears cache entries using a policy. Works interval-based or on entry creation.                                                                                                             |
| readThrough                      | When in "read-through" mode, cache misses that occur due to cache entries not existing as a result of performing a "get" will appropriately cause the configured CacheLoader to be invoked. |
| writeThrough                     | When in "write-through" mode, cache updates that occur as a result of performing "put" operations will appropriately cause the configured CacheWriter to be invoked.                        |
| storeByValue                     | When a cache is storeByValue, any mutation to the key or value does not affect the key of value stored in the cache.                                                                        |
| statisticsEnabled                | Checks whether statistics collection is enabled in this cache.                                                                                                                              |
| managementEnabled                | Checks whether management is enabled on this cache.                                                                                                                                         |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://manual.docs.microstream.one/cache/configuration/properties.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
